> ## Documentation Index
> Fetch the complete documentation index at: https://docs.data-hub.verolabs.co/llms.txt
> Use this file to discover all available pages before exploring further.

# List instruments

> GET /v1/instruments — search available instruments

Search the available instrument universe by asset class, exchange and symbol prefix.

<CardGroup cols={2}>
  <Card title="Search by symbol" icon="circle-check">
    Use `q` to search by symbol prefix.
  </Card>

  <Card title="Filter universe" icon="circle-check">
    Use `asset_class` and `exchange` to narrow results.
  </Card>
</CardGroup>

## Common use cases

* Build symbol autocomplete.
* Check whether a symbol is available.
* Filter the universe before requesting ticks or candles.

## Key parameters

* `asset_class`: asset group such as stock, crypto or fx.
* `exchange`: market or venue identifier.
* `q`: case-insensitive symbol prefix.
* `limit` and `cursor`: pagination controls.


## OpenAPI

````yaml GET /v1/instruments
openapi: 3.0.3
info:
  title: Vero Data Hub API
  version: 1.0.0
  description: >-
    REST API cho dữ liệu thị trường, dữ liệu tham chiếu, dữ liệu cơ bản, quỹ, dữ
    liệu vĩ mô, tin tức và độ mới dữ liệu.
servers:
  - url: https://api-gw.verolabs.co
    description: Base URL của API
security:
  - ApiKeyAuth: []
tags:
  - name: reference
  - name: tick
  - name: candles
  - name: fx
  - name: bonds
  - name: macro
  - name: sentiment
  - name: calendar
  - name: funds
  - name: fa
  - name: news
  - name: ops
paths:
  /v1/instruments:
    get:
      tags:
        - reference
      summary: Danh sách mã giao dịch
      parameters:
        - name: asset_class
          in: query
          schema:
            type: string
            example: crypto
        - name: exchange
          in: query
          schema:
            type: string
            example: BINANCE
        - name: q
          in: query
          schema:
            type: string
            example: BTC
          description: Tiền tố symbol, không phân biệt hoa thường
        - $ref: '#/components/parameters/Limit'
        - $ref: '#/components/parameters/Cursor'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InstrumentPage'
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '503':
          $ref: '#/components/responses/Unavailable'
components:
  parameters:
    Limit:
      name: limit
      in: query
      schema:
        type: integer
        minimum: 1
        maximum: 10000
        default: 1000
        example: 100
    Cursor:
      name: cursor
      in: query
      schema:
        type: string
      description: Token phân trang lấy từ `next_cursor` trước đó.
  schemas:
    InstrumentPage:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/Instrument'
        next_cursor:
          type: string
          nullable: true
    Instrument:
      type: object
      required:
        - symbol
        - asset_class
        - status
      properties:
        symbol:
          type: string
        asset_class:
          type: string
        exchange:
          type: string
          nullable: true
        base:
          type: string
          nullable: true
        quote:
          type: string
          nullable: true
        currency:
          type: string
          nullable: true
        isin:
          type: string
          nullable: true
        status:
          type: string
        listing_date:
          type: string
          format: date
          nullable: true
        delisting_date:
          type: string
          format: date
          nullable: true
    Problem:
      type: object
      required:
        - type
        - title
        - status
      properties:
        type:
          type: string
          format: uri
          example: invalid-param
        title:
          type: string
          example: Tham số truy vấn không hợp lệ
        status:
          type: integer
          example: 400
        detail:
          type: string
          example: cần có tham số "from"
        instance:
          type: string
        request_id:
          type: string
  responses:
    BadRequest:
      description: Tham số yêu cầu không hợp lệ.
      content:
        application/problem+json:
          schema:
            $ref: '#/components/schemas/Problem'
    Unauthorized:
      description: Thiếu hoặc sai API key.
      content:
        application/problem+json:
          schema:
            $ref: '#/components/schemas/Problem'
    Unavailable:
      description: API tạm thời không sẵn sàng.
      content:
        application/problem+json:
          schema:
            $ref: '#/components/schemas/Problem'
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: X-API-KEY
      description: API key được cấp cho tài khoản của bạn.

````